//
// $Id: RPMVersionCompareData.h,v 1.1 2004/06/01 17:05:20 bakerj Exp $
//
//************************** Property of the MITRE Corporation ***************************//
//
// Copyright (c) 2003 - The MITRE Corporation
//
// This file is part of the Query-based Network Assessment project.
//
// The Query-based Network Assessment is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License.
//
// The Query-based Network Assessment is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with the
// Query-based Network Assessment; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
//****************************************************************************************//
//
//  file:	RPMVersionCompareData.h
//  author: Jon Baker	
//  date:   11 February 2004
//
//	This class will store all data for a red hat uname. 
//	The class is a child class of ProbeData and implments the Write() function.
//****************************************************************************************//
//	TO DO:
//	Move all data to private data - This will effect the probe...
//
//****************************************************************************************//

#ifndef __RPMVERSIONCOMPAREDATA_H__
#define __RPMVERSIONCOMPAREDATA_H__

#include "ProbeData.h"

class RPMVersionCompareData : public ProbeData
{
public:
	// -----------------------------------------------------------------------
	//	Constructors & Destructors
	// -----------------------------------------------------------------------
	RPMVersionCompareData(string, string, string, string);
	RPMVersionCompareData();
	~RPMVersionCompareData();

	// -----------------------------------------------------------------------
	//	Public members
	// -----------------------------------------------------------------------
	void Write(DBInterface*);

	// -----------------------------------------------------------------------
	//	Public data
	// -----------------------------------------------------------------------	
	TypedData *name;
	string tested_epoch;
	string tested_version;
	string tested_release;
	string installed_version;
	string msg;

private:
	// -----------------------------------------------------------------------
	//	Private members
	// -----------------------------------------------------------------------
	void Parse(string);
};

#endif
